Fix a bug intruduced when refactoring GenerateFree
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34
35 # Note: these are automake-specific variables, and must be named after
36 # the directory + 'dir' suffix
37 clientdir = $(pkgpythondir)/client
38 hypervisordir = $(pkgpythondir)/hypervisor
39 httpdir = $(pkgpythondir)/http
40 masterddir = $(pkgpythondir)/masterd
41 confddir = $(pkgpythondir)/confd
42 rapidir = $(pkgpythondir)/rapi
43 serverdir = $(pkgpythondir)/server
44 watcherdir = $(pkgpythondir)/watcher
45 impexpddir = $(pkgpythondir)/impexpd
46 utilsdir = $(pkgpythondir)/utils
47 toolsdir = $(pkglibdir)/tools
48 iallocatorsdir = $(pkglibdir)/iallocators
49 pytoolsdir = $(pkgpythondir)/tools
50 docdir = $(datadir)/doc/$(PACKAGE)
51 myexeclibdir = $(pkglibdir)
52
53 # Delete output file if an error occurred while building it
54 .DELETE_ON_ERROR:
55
56 HTOOLS_DIRS = \
57         htools \
58         htools/Ganeti \
59         htools/Ganeti/Confd \
60         htools/Ganeti/HTools \
61         htools/Ganeti/HTools/Program
62
63 DIRS = \
64         autotools \
65         daemons \
66         devel \
67         doc \
68         doc/examples \
69         doc/examples/hooks \
70         doc/examples/gnt-debug \
71         $(HTOOLS_DIRS) \
72         lib \
73         lib/client \
74         lib/build \
75         lib/confd \
76         lib/http \
77         lib/hypervisor \
78         lib/impexpd \
79         lib/masterd \
80         lib/rapi \
81         lib/server \
82         lib/tools \
83         lib/utils \
84         lib/watcher \
85         man \
86         qa \
87         test \
88         test/data \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/data/ovfdata \
92         test/data/ovfdata/other \
93         tools
94
95 BUILDTIME_DIR_AUTOCREATE = \
96         scripts \
97         $(APIDOC_DIR) \
98         $(APIDOC_PY_DIR) \
99         $(APIDOC_HS_DIR) \
100         $(APIDOC_HS_DIR)/Ganeti \
101         $(APIDOC_HS_DIR)/Ganeti/Confd \
102         $(APIDOC_HS_DIR)/Ganeti/HTools \
103         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104         $(COVERAGE_DIR) \
105         $(COVERAGE_PY_DIR) \
106         $(COVERAGE_HS_DIR) \
107         .hpc
108
109 BUILDTIME_DIRS = \
110         $(BUILDTIME_DIR_AUTOCREATE) \
111         doc/html
112
113 DIRCHECK_EXCLUDE = \
114         $(BUILDTIME_DIRS) \
115         ganeti-[0-9]*.[0-9]*.[0-9]* \
116         doc/html/_*
117
118 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119
120 # some helper vars
121 COVERAGE_DIR = doc/coverage
122 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 APIDOC_DIR = doc/api
125 APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127
128 MAINTAINERCLEANFILES = \
129         $(docpng) \
130         $(maninput) \
131         doc/install-quick.rst \
132         doc/news.rst \
133         doc/upgrade.rst \
134         vcs-version
135
136 maintainer-clean-local:
137         rm -rf $(BUILDTIME_DIRS)
138
139 CLEANFILES = \
140         $(addsuffix /*.py[co],$(DIRS)) \
141         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
143         $(all_dirfiles) \
144         $(PYTHON_BOOTSTRAP) \
145         epydoc.conf \
146         autotools/replace_vars.sed \
147         daemons/daemon-util \
148         daemons/ganeti-cleaner \
149         devel/upload \
150         $(BUILT_EXAMPLES) \
151         doc/examples/bash_completion \
152         lib/_generated_rpc.py \
153         $(man_MANS) \
154         $(manhtml) \
155         tools/kvm-ifup \
156         stamp-srclinks \
157         $(nodist_pkgpython_PYTHON) \
158         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159         $(HS_BUILT_TEST_HELPERS) \
160         .hpc/*.mix htools/*.tix \
161         doc/hs-lint.html
162
163 # BUILT_SOURCES should only be used as a dependency on phony
164 # targets. Otherwise it'll cause the target to rebuild every time.
165 BUILT_SOURCES = \
166   $(built_base_sources) \
167         $(BUILT_PYTHON_SOURCES) \
168         $(PYTHON_BOOTSTRAP)
169
170 built_base_sources = \
171         ganeti \
172         stamp-srclinks \
173         $(all_dirfiles)
174
175 built_python_base_sources = \
176         lib/_autoconf.py \
177         lib/_vcsversion.py
178
179 BUILT_PYTHON_SOURCES = \
180         $(built_python_base_sources) \
181         lib/_generated_rpc.py
182
183 # Generating the RPC wrappers depends on many things, so make sure it's built at
184 # the end of the built sources
185 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186
187 # these are all built from the underlying %.in sources
188 BUILT_EXAMPLES = \
189         doc/examples/ganeti-kvm-poweroff.initd \
190         doc/examples/ganeti.cron \
191         doc/examples/ganeti.initd \
192         doc/examples/gnt-config-backup \
193         doc/examples/hooks/ipsec
194
195 nodist_pkgpython_PYTHON = \
196         $(BUILT_PYTHON_SOURCES)
197
198 noinst_PYTHON = \
199         lib/build/__init__.py \
200         lib/build/sphinx_ext.py \
201         lib/build/shell_example_lexer.py
202
203 pkgpython_PYTHON = \
204         lib/__init__.py \
205         lib/asyncnotifier.py \
206         lib/backend.py \
207         lib/bdev.py \
208         lib/bootstrap.py \
209         lib/cli.py \
210         lib/cmdlib.py \
211         lib/compat.py \
212         lib/config.py \
213         lib/constants.py \
214         lib/daemon.py \
215         lib/errors.py \
216         lib/ht.py \
217         lib/jqueue.py \
218         lib/jstore.py \
219         lib/locking.py \
220         lib/luxi.py \
221         lib/mcpu.py \
222         lib/netutils.py \
223         lib/objects.py \
224         lib/opcodes.py \
225         lib/ovf.py \
226         lib/qlang.py \
227         lib/query.py \
228         lib/rpc.py \
229         lib/rpc_defs.py \
230         lib/runtime.py \
231         lib/serializer.py \
232         lib/ssconf.py \
233         lib/ssh.py \
234         lib/storage.py \
235         lib/uidpool.py \
236         lib/network.py \
237         lib/workerpool.py
238
239 client_PYTHON = \
240         lib/client/__init__.py \
241         lib/client/gnt_backup.py \
242         lib/client/gnt_cluster.py \
243         lib/client/gnt_debug.py \
244         lib/client/gnt_group.py \
245         lib/client/gnt_instance.py \
246         lib/client/gnt_job.py \
247         lib/client/gnt_node.py \
248         lib/client/gnt_network.py \
249         lib/client/gnt_os.py
250
251 hypervisor_PYTHON = \
252         lib/hypervisor/__init__.py \
253         lib/hypervisor/hv_base.py \
254         lib/hypervisor/hv_chroot.py \
255         lib/hypervisor/hv_fake.py \
256         lib/hypervisor/hv_kvm.py \
257         lib/hypervisor/hv_lxc.py \
258         lib/hypervisor/hv_xen.py
259
260 rapi_PYTHON = \
261         lib/rapi/__init__.py \
262         lib/rapi/baserlib.py \
263         lib/rapi/client.py \
264         lib/rapi/client_utils.py \
265         lib/rapi/connector.py \
266         lib/rapi/rlib2.py \
267         lib/rapi/testutils.py
268
269 http_PYTHON = \
270         lib/http/__init__.py \
271         lib/http/auth.py \
272         lib/http/client.py \
273         lib/http/server.py
274
275 confd_PYTHON = \
276         lib/confd/__init__.py \
277         lib/confd/client.py \
278         lib/confd/querylib.py \
279         lib/confd/server.py
280
281 masterd_PYTHON = \
282         lib/masterd/__init__.py \
283         lib/masterd/instance.py
284
285 impexpd_PYTHON = \
286         lib/impexpd/__init__.py
287
288 watcher_PYTHON = \
289         lib/watcher/__init__.py \
290         lib/watcher/nodemaint.py \
291         lib/watcher/state.py
292
293 server_PYTHON = \
294         lib/server/__init__.py \
295         lib/server/confd.py \
296         lib/server/masterd.py \
297         lib/server/noded.py \
298         lib/server/rapi.py
299
300 pytools_PYTHON = \
301         lib/tools/__init__.py \
302         lib/tools/ensure_dirs.py
303
304 utils_PYTHON = \
305         lib/utils/__init__.py \
306         lib/utils/algo.py \
307         lib/utils/filelock.py \
308         lib/utils/hash.py \
309         lib/utils/io.py \
310         lib/utils/log.py \
311         lib/utils/mlock.py \
312         lib/utils/nodesetup.py \
313         lib/utils/process.py \
314         lib/utils/retry.py \
315         lib/utils/text.py \
316         lib/utils/wrapper.py \
317         lib/utils/x509.py
318
319 docrst = \
320         doc/admin.rst \
321         doc/design-2.0.rst \
322         doc/design-2.1.rst \
323         doc/design-2.2.rst \
324         doc/design-2.3.rst \
325         doc/design-htools-2.3.rst \
326         doc/design-2.4.rst \
327         doc/design-2.5.rst \
328         doc/design-draft.rst \
329         doc/design-oob.rst \
330         doc/design-cpu-pinning.rst \
331         doc/design-query2.rst \
332         doc/design-x509-ca.rst \
333         doc/design-http-server.rst \
334         doc/design-impexp2.rst \
335         doc/design-lu-generated-jobs.rst \
336         doc/design-multi-reloc.rst \
337         doc/design-network.rst \
338         doc/design-chained-jobs.rst \
339         doc/design-ovf-support.rst \
340         doc/design-resource-model.rst \
341         doc/cluster-merge.rst \
342         doc/design-shared-storage.rst \
343         doc/design-node-state-cache.rst \
344         doc/design-virtual-clusters.rst \
345         doc/design-query-splitting.rst \
346         doc/devnotes.rst \
347         doc/glossary.rst \
348         doc/hooks.rst \
349         doc/iallocator.rst \
350         doc/index.rst \
351         doc/install-quick.rst \
352         doc/install.rst \
353         doc/locking.rst \
354         doc/move-instance.rst \
355         doc/news.rst \
356         doc/ovfconverter.rst \
357         doc/rapi.rst \
358         doc/security.rst \
359         doc/upgrade.rst \
360         doc/walkthrough.rst
361
362 HS_PROGS = htools/htools
363 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
364
365 HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
366 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
367 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
368
369 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
370 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
371 HEXTRA =
372 # internal extra flags (used for htools/test mainly)
373 HEXTRA_INT =
374 # exclude options for coverage reports
375 HPCEXCL = --exclude Main \
376         --exclude Ganeti.Constants \
377         --exclude Ganeti.THH \
378         --exclude Ganeti.HTools.QC \
379         --exclude Ganeti.HTools.QCHelper \
380         --exclude Ganeti.HTools.Version
381
382 HS_LIB_SRCS = \
383         htools/Ganeti/HTools/CLI.hs \
384         htools/Ganeti/HTools/Cluster.hs \
385         htools/Ganeti/HTools/Compat.hs \
386         htools/Ganeti/HTools/Container.hs \
387         htools/Ganeti/HTools/ExtLoader.hs \
388         htools/Ganeti/HTools/Group.hs \
389         htools/Ganeti/HTools/IAlloc.hs \
390         htools/Ganeti/HTools/Instance.hs \
391         htools/Ganeti/HTools/JSON.hs \
392         htools/Ganeti/HTools/Loader.hs \
393         htools/Ganeti/HTools/Luxi.hs \
394         htools/Ganeti/HTools/Node.hs \
395         htools/Ganeti/HTools/PeerMap.hs \
396         htools/Ganeti/HTools/QC.hs \
397         htools/Ganeti/HTools/QCHelper.hs \
398         htools/Ganeti/HTools/Rapi.hs \
399         htools/Ganeti/HTools/Simu.hs \
400         htools/Ganeti/HTools/Text.hs \
401         htools/Ganeti/HTools/Types.hs \
402         htools/Ganeti/HTools/Utils.hs \
403         htools/Ganeti/HTools/Program.hs \
404         htools/Ganeti/HTools/Program/Hail.hs \
405         htools/Ganeti/HTools/Program/Hbal.hs \
406         htools/Ganeti/HTools/Program/Hcheck.hs \
407         htools/Ganeti/HTools/Program/Hinfo.hs \
408         htools/Ganeti/HTools/Program/Hscan.hs \
409         htools/Ganeti/HTools/Program/Hspace.hs \
410         htools/Ganeti/BasicTypes.hs \
411         htools/Ganeti/Confd.hs \
412         htools/Ganeti/Confd/Server.hs \
413         htools/Ganeti/Config.hs \
414         htools/Ganeti/Daemon.hs \
415         htools/Ganeti/Hash.hs \
416         htools/Ganeti/Jobs.hs \
417         htools/Ganeti/Logging.hs \
418         htools/Ganeti/Luxi.hs \
419         htools/Ganeti/Objects.hs \
420         htools/Ganeti/OpCodes.hs \
421         htools/Ganeti/Runtime.hs \
422         htools/Ganeti/Ssconf.hs \
423         htools/Ganeti/THH.hs
424
425 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
426 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
427
428 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
429
430 # Note: we use here an order-only prerequisite, as the contents of
431 # _autoconf.py are not actually influencing the html build output: it
432 # has to exist in order for the sphinx module to be loaded
433 # successfully, but we certainly don't want the docs to be rebuilt if
434 # it changes
435 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
436         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
437         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
438         | $(BUILT_PYTHON_SOURCES)
439         @test -n "$(SPHINX)" || \
440             { echo 'sphinx-build' not found during configure; exit 1; }
441         @mkdir_p@ $(dir $@)
442         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
443             -d . \
444             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
445             -D release="$(PACKAGE_VERSION)" \
446             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
447         rm -f doc/html/.buildinfo doc/html/objects.inv
448         touch $@
449
450 doc/html: doc/html/index.html
451
452 doc/install-quick.rst: INSTALL
453 doc/news.rst: NEWS
454 doc/upgrade.rst: UPGRADE
455
456 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
457         set -e; \
458         { echo '.. This file is automatically updated at build time from $<.'; \
459           echo '.. Do not edit.'; \
460           echo; \
461           cat $<; \
462         } > $@
463
464 docdot = \
465         doc/arch-2.0.dot \
466         doc/design-2.1-lock-acquire.dot \
467         doc/design-2.1-lock-release.dot
468
469 docpng = $(patsubst %.dot,%.png,$(docdot))
470
471 # Things to build but not to install (add it to EXTRA_DIST if it should be
472 # distributed)
473 noinst_DATA = \
474         devel/upload \
475         doc/html \
476         $(BUILT_EXAMPLES) \
477         doc/examples/bash_completion \
478         $(manhtml)
479
480 gnt_scripts = \
481         scripts/gnt-backup \
482         scripts/gnt-cluster \
483         scripts/gnt-debug \
484         scripts/gnt-group \
485         scripts/gnt-instance \
486         scripts/gnt-job \
487         scripts/gnt-network \
488         scripts/gnt-node \
489         scripts/gnt-os
490
491 PYTHON_BOOTSTRAP_SBIN = \
492         daemons/ganeti-masterd \
493         daemons/ganeti-noded \
494         daemons/ganeti-watcher \
495         daemons/ganeti-rapi \
496         $(gnt_scripts)
497
498 if PY_CONFD
499 PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
500 endif
501
502 PYTHON_BOOTSTRAP = \
503         $(PYTHON_BOOTSTRAP_SBIN) \
504         tools/ensure-dirs
505
506 qa_scripts = \
507         qa/__init__.py \
508         qa/ganeti-qa.py \
509         qa/qa_cluster.py \
510         qa/qa_config.py \
511         qa/qa_daemon.py \
512         qa/qa_env.py \
513         qa/qa_error.py \
514         qa/qa_group.py \
515         qa/qa_instance.py \
516         qa/qa_job.py \
517         qa/qa_node.py \
518         qa/qa_os.py \
519         qa/qa_rapi.py \
520         qa/qa_tags.py \
521         qa/qa_utils.py
522
523 bin_SCRIPTS =
524 if WANT_HTOOLS
525 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
526 install-exec-hook:
527         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
528 # FIXME: this is a hardcoded logic, instead of auto-resolving
529         $(LN_S) -f ../../../bin/htools \
530                    $(DESTDIR)$(iallocatorsdir)/hail
531         for role in $(HS_BIN_ROLES); do \
532                 $(LN_S) -f htools \
533                            $(DESTDIR)$(bindir)/$$role ; \
534         done
535 if HS_CONFD
536         mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
537 endif
538 endif
539
540 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
541         @if [ -z "$(HTOOLS)" ]; then \
542           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
543           exit 1; \
544         fi
545         @BINARY=$(@:htools/%=%); \
546         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
547           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
548           exit 1; \
549         fi
550         rm -f $(@:htools/%=%).tix
551         BINARY=$(@:htools/%=%); $(GHC) --make \
552           $(HFLAGS) \
553           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
554           -osuf $$BINARY.o -hisuf $$BINARY.hi \
555           $(HEXTRA) $(HEXTRA_INT) $@
556         @touch "$@"
557
558 # for the htools/test binary, we need to enable profiling/coverage
559 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
560         -fno-warn-monomorphism-restriction -fno-warn-orphans \
561         -fno-warn-missing-methods -fno-warn-unused-imports
562
563 # we compile the hpc-htools binary with the program coverage
564 htools/hpc-htools: HEXTRA_INT=-fhpc
565
566 # test dependency
567 htools/offline-tests.sh: htools/hpc-htools
568
569 # rules for building profiling-enabled versions of the haskell
570 # programs: hs-prof does the full two-step build, whereas
571 # hs-prof-quick does only the final rebuild (hs-prof must have been
572 # run before)
573 .PHONY: hs-prof hs-prof-quick
574 hs-prof:
575         $(MAKE) clean
576         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
577         rm -f $(HS_ALL_PROGS)
578         $(MAKE) hs-prof-quick
579
580 hs-prof-quick:
581         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
582
583 dist_sbin_SCRIPTS = \
584         tools/ganeti-listrunner
585
586 nodist_sbin_SCRIPTS = \
587         $(PYTHON_BOOTSTRAP_SBIN) \
588         daemons/ganeti-cleaner
589
590 if HS_CONFD
591 nodist_sbin_SCRIPTS += htools/hconfd
592 endif
593
594 python_scripts = \
595         tools/burnin \
596         tools/cfgshell \
597         tools/cfgupgrade \
598         tools/cfgupgrade12 \
599         tools/cluster-merge \
600         tools/confd-client \
601         tools/fmtjson \
602         tools/lvmstrap \
603         tools/move-instance \
604         tools/ovfconverter \
605         tools/setup-ssh \
606         tools/sanitize-config
607
608 dist_tools_SCRIPTS = \
609         $(python_scripts) \
610         tools/kvm-console-wrapper \
611         tools/xm-console-wrapper \
612         tools/master-ip-setup
613
614 pkglib_python_scripts = \
615         daemons/import-export \
616         tools/check-cert-expired
617
618 nodist_pkglib_python_scripts = \
619         tools/ensure-dirs
620
621 myexeclib_SCRIPTS = \
622         daemons/daemon-util \
623         tools/kvm-ifup \
624         $(pkglib_python_scripts)
625
626 nodist_myexeclib_SCRIPTS = \
627         $(nodist_pkglib_python_scripts)
628
629 EXTRA_DIST = \
630         NEWS \
631         UPGRADE \
632         epydoc.conf.in \
633         pylintrc \
634         autotools/build-bash-completion \
635         autotools/build-rpc \
636         autotools/check-header \
637         autotools/check-python-code \
638         autotools/check-imports \
639         autotools/check-man-dashes \
640         autotools/check-man-warnings \
641         autotools/check-news \
642         autotools/check-tar \
643         autotools/check-version \
644         autotools/convert-constants \
645         autotools/docpp \
646         autotools/gen-coverage \
647         autotools/testrunner \
648         autotools/wrong-hardcoded-paths \
649         $(RUN_IN_TEMPDIR) \
650         daemons/daemon-util.in \
651         daemons/ganeti-cleaner.in \
652         $(pkglib_python_scripts) \
653         devel/upload.in \
654         tools/kvm-ifup.in \
655         $(docdot) \
656         $(docpng) \
657         $(docrst) \
658         doc/conf.py \
659         doc/html \
660         $(BUILT_EXAMPLES:%=%.in) \
661         doc/examples/ganeti.default \
662         doc/examples/ganeti.default-debug \
663         doc/examples/hooks/ethers \
664         doc/examples/gnt-debug/README \
665         doc/examples/gnt-debug/delay0.json \
666         doc/examples/gnt-debug/delay50.json \
667         test/lockperf.py \
668         test/testutils.py \
669         test/mocks.py \
670         $(dist_TESTS) \
671         $(TEST_FILES) \
672         man/footer.rst \
673         $(manrst) \
674         $(maninput) \
675         qa/qa-sample.json \
676         $(qa_scripts) \
677         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
678         $(HS_PROG_SRCS) \
679         htools/lint-hints.hs \
680         htools/cli-tests-defs.sh \
681         htools/offline-test.sh
682
683 man_MANS = \
684         man/ganeti.7 \
685         man/ganeti-cleaner.8 \
686         man/ganeti-confd.8 \
687         man/ganeti-listrunner.8 \
688         man/ganeti-masterd.8 \
689         man/ganeti-noded.8 \
690         man/ganeti-os-interface.7 \
691         man/ganeti-rapi.8 \
692         man/ganeti-watcher.8 \
693         man/gnt-backup.8 \
694         man/gnt-cluster.8 \
695         man/gnt-debug.8 \
696         man/gnt-group.8 \
697         man/gnt-network.8 \
698         man/gnt-instance.8 \
699         man/gnt-job.8 \
700         man/gnt-node.8 \
701         man/gnt-os.8 \
702         man/hail.1 \
703         man/hbal.1 \
704         man/hcheck.1 \
705         man/hinfo.1 \
706         man/hscan.1 \
707         man/hspace.1 \
708         man/htools.1
709
710 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
711 manhtml = $(patsubst %.rst,%.html,$(manrst))
712 mangen = $(patsubst %.rst,%.gen,$(manrst))
713 maninput = \
714         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
715         $(patsubst %.html,%.html.in,$(manhtml)) \
716         man/footer.man man/footer.html $(mangen)
717
718 TEST_FILES = \
719         test/data/bdev-drbd-8.0.txt \
720         test/data/bdev-drbd-8.3.txt \
721         test/data/bdev-drbd-disk.txt \
722         test/data/bdev-drbd-net-ip4.txt \
723         test/data/bdev-drbd-net-ip6.txt \
724         test/data/cert1.pem \
725         test/data/ip-addr-show-dummy0.txt \
726         test/data/ip-addr-show-lo-ipv4.txt \
727         test/data/ip-addr-show-lo-ipv6.txt \
728         test/data/ip-addr-show-lo-oneline-ipv4.txt \
729         test/data/ip-addr-show-lo-oneline-ipv6.txt \
730         test/data/ip-addr-show-lo-oneline.txt \
731         test/data/ip-addr-show-lo.txt \
732         test/data/proc_drbd8.txt \
733         test/data/proc_drbd80-emptyline.txt \
734         test/data/proc_drbd83.txt \
735         test/data/proc_drbd83_sync.txt \
736         test/data/proc_drbd83_sync_krnl2.6.39.txt \
737         test/data/kvm_1.0_help.txt \
738         test/data/kvm_0.15.90_help.txt \
739         test/data/kvm_0.12.5_help.txt \
740         test/data/kvm_0.9.1_help.txt \
741         test/data/sys_drbd_usermode_helper.txt \
742         test/data/htools/hail-alloc-drbd.json \
743         test/data/htools/hail-change-group.json \
744         test/data/htools/hail-invalid-reloc.json \
745         test/data/htools/hail-node-evac.json \
746         test/data/htools/hail-reloc-drbd.json \
747         test/data/htools/hbal-split-insts.data \
748         test/data/htools/common-suffix.data \
749         test/data/htools/invalid-node.data \
750         test/data/htools/missing-resources.data \
751         test/data/htools/rapi/groups.json \
752         test/data/htools/rapi/info.json \
753         test/data/htools/rapi/instances.json \
754         test/data/htools/rapi/nodes.json \
755         test/data/ovfdata/compr_disk.vmdk.gz \
756         test/data/ovfdata/config.ini \
757         test/data/ovfdata/corrupted_resources.ovf \
758         test/data/ovfdata/empty.ini \
759         test/data/ovfdata/empty.ovf \
760         test/data/ovfdata/ganeti.mf \
761         test/data/ovfdata/ganeti.ovf \
762         test/data/ovfdata/gzip_disk.ovf \
763         test/data/ovfdata/new_disk.vmdk \
764         test/data/ovfdata/no_disk.ini \
765         test/data/ovfdata/no_disk_in_ref.ovf \
766         test/data/ovfdata/no_os.ini \
767         test/data/ovfdata/no_ovf.ova \
768         test/data/ovfdata/ova.ova \
769         test/data/ovfdata/second_disk.vmdk \
770         test/data/ovfdata/rawdisk.raw \
771         test/data/ovfdata/unsafe_path.ini \
772         test/data/ovfdata/virtualbox.ovf \
773         test/data/ovfdata/wrong_extension.ovd \
774         test/data/ovfdata/wrong_config.ini \
775         test/data/ovfdata/wrong_manifest.mf \
776         test/data/ovfdata/wrong_manifest.ovf \
777         test/data/ovfdata/wrong_ova.ova \
778         test/data/ovfdata/wrong_xml.ovf \
779         test/data/ovfdata/other/rawdisk.raw \
780         test/data/vgreduce-removemissing-2.02.02.txt \
781         test/data/vgreduce-removemissing-2.02.66-fail.txt \
782         test/data/vgreduce-removemissing-2.02.66-ok.txt \
783         test/data/vgs-missing-pvs-2.02.02.txt \
784         test/data/vgs-missing-pvs-2.02.66.txt \
785         test/import-export_unittest-helper \
786         test/gnt-cli.test \
787         test/ganeti-cli.test \
788         test/htools-balancing.test \
789         test/htools-basic.test \
790         test/htools-dynutil.test \
791         test/htools-excl.test \
792         test/htools-hail.test \
793         test/htools-hspace.test \
794         test/htools-invalid.test \
795         test/htools-multi-group.test \
796         test/htools-no-backend.test \
797         test/htools-rapi.test \
798         test/htools-single-group.test \
799         test/htools-text-backend.test
800
801 python_tests = \
802         doc/examples/rapi_testutils.py \
803         test/ganeti.asyncnotifier_unittest.py \
804         test/ganeti.backend_unittest.py \
805         test/ganeti.bdev_unittest.py \
806         test/ganeti.cli_unittest.py \
807         test/ganeti.client.gnt_cluster_unittest.py \
808         test/ganeti.client.gnt_instance_unittest.py \
809         test/ganeti.daemon_unittest.py \
810         test/ganeti.cmdlib_unittest.py \
811         test/ganeti.compat_unittest.py \
812         test/ganeti.confd.client_unittest.py \
813         test/ganeti.config_unittest.py \
814         test/ganeti.constants_unittest.py \
815         test/ganeti.errors_unittest.py \
816         test/ganeti.hooks_unittest.py \
817         test/ganeti.ht_unittest.py \
818         test/ganeti.http_unittest.py \
819         test/ganeti.hypervisor_unittest.py \
820         test/ganeti.hypervisor.hv_chroot_unittest.py \
821         test/ganeti.hypervisor.hv_fake_unittest.py \
822         test/ganeti.hypervisor.hv_kvm_unittest.py \
823         test/ganeti.hypervisor.hv_lxc_unittest.py \
824         test/ganeti.hypervisor.hv_xen_unittest.py \
825         test/ganeti.impexpd_unittest.py \
826         test/ganeti.jqueue_unittest.py \
827         test/ganeti.locking_unittest.py \
828         test/ganeti.luxi_unittest.py \
829         test/ganeti.masterd.instance_unittest.py \
830         test/ganeti.mcpu_unittest.py \
831         test/ganeti.netutils_unittest.py \
832         test/ganeti.objects_unittest.py \
833         test/ganeti.opcodes_unittest.py \
834         test/ganeti.ovf_unittest.py \
835         test/ganeti.qlang_unittest.py \
836         test/ganeti.query_unittest.py \
837         test/ganeti.rapi.baserlib_unittest.py \
838         test/ganeti.rapi.client_unittest.py \
839         test/ganeti.rapi.resources_unittest.py \
840         test/ganeti.rapi.rlib2_unittest.py \
841         test/ganeti.rapi.testutils_unittest.py \
842         test/ganeti.rpc_unittest.py \
843         test/ganeti.runtime_unittest.py \
844         test/ganeti.serializer_unittest.py \
845         test/ganeti.ssh_unittest.py \
846         test/ganeti.storage_unittest.py \
847         test/ganeti.tools.ensure_dirs_unittest.py \
848         test/ganeti.uidpool_unittest.py \
849         test/ganeti.utils.algo_unittest.py \
850         test/ganeti.utils.filelock_unittest.py \
851         test/ganeti.utils.hash_unittest.py \
852         test/ganeti.utils.io_unittest.py \
853         test/ganeti.utils.log_unittest.py \
854         test/ganeti.utils.mlock_unittest.py \
855         test/ganeti.utils.nodesetup_unittest.py \
856         test/ganeti.utils.process_unittest.py \
857         test/ganeti.utils.retry_unittest.py \
858         test/ganeti.utils.text_unittest.py \
859         test/ganeti.utils.wrapper_unittest.py \
860         test/ganeti.utils.x509_unittest.py \
861         test/ganeti.utils_unittest.py \
862         test/ganeti.workerpool_unittest.py \
863         test/qa.qa_config_unittest.py \
864         test/cfgupgrade_unittest.py \
865         test/docs_unittest.py \
866         test/pycurl_reset_unittest.py \
867         test/tempfile_fork_unittest.py
868 if HAS_FAKEROOT
869 python_tests += test/ganeti.utils.io_unittest-runasroot.py
870 endif
871
872 haskell_tests = htools/test
873
874 dist_TESTS = \
875         test/check-cert-expired_unittest.bash \
876         test/daemon-util_unittest.bash \
877         test/ganeti-cleaner_unittest.bash \
878         test/import-export_unittest.bash \
879         test/cli-test.bash \
880         $(python_tests)
881
882 nodist_TESTS =
883 check_SCRIPTS =
884
885 if WANT_HTOOLSTESTS
886 nodist_TESTS += $(haskell_tests)
887 dist_TESTS += htools/offline-test.sh
888 check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
889 endif
890
891 TESTS = $(dist_TESTS) $(nodist_TESTS)
892
893 # Environment for all tests
894 PLAIN_TESTS_ENVIRONMENT = \
895         PYTHONPATH=. \
896         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
897         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
898         $(RUN_IN_TEMPDIR)
899
900 # Environment for tests run by automake
901 TESTS_ENVIRONMENT = \
902         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
903
904 all_python_code = \
905         $(dist_sbin_SCRIPTS) \
906         $(python_scripts) \
907         $(pkglib_python_scripts) \
908         $(nodist_pkglib_python_scripts) \
909         $(python_tests) \
910         $(pkgpython_PYTHON) \
911         $(client_PYTHON) \
912         $(hypervisor_PYTHON) \
913         $(rapi_PYTHON) \
914         $(server_PYTHON) \
915         $(pytools_PYTHON) \
916         $(http_PYTHON) \
917         $(confd_PYTHON) \
918         $(masterd_PYTHON) \
919         $(impexpd_PYTHON) \
920         $(utils_PYTHON) \
921         $(watcher_PYTHON) \
922         $(noinst_PYTHON) \
923         $(qa_scripts)
924
925 srclink_files = \
926         man/footer.rst \
927         test/check-cert-expired_unittest.bash \
928         test/daemon-util_unittest.bash \
929         test/ganeti-cleaner_unittest.bash \
930         test/import-export_unittest.bash \
931         test/cli-test.bash \
932         htools/offline-test.sh \
933         htools/cli-tests-defs.sh \
934         $(all_python_code) \
935         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
936
937 check_python_code = \
938         $(BUILD_BASH_COMPLETION) \
939         $(CHECK_IMPORTS) \
940         $(CHECK_HEADER) \
941         $(DOCPP) \
942         $(all_python_code)
943
944 lint_python_code = \
945         ganeti \
946         ganeti/http/server.py \
947         $(dist_sbin_SCRIPTS) \
948         $(python_scripts) \
949         $(pkglib_python_scripts) \
950         $(BUILD_BASH_COMPLETION) \
951         $(CHECK_IMPORTS) \
952         $(CHECK_HEADER) \
953         $(DOCPP) \
954         $(PYTHON_BOOTSTRAP)
955
956 standalone_python_modules = \
957         lib/rapi/client.py \
958         tools/ganeti-listrunner
959
960 pep8_python_code = \
961         ganeti \
962         ganeti/http/server.py \
963         $(dist_sbin_SCRIPTS) \
964         $(python_scripts) \
965         $(pkglib_python_scripts) \
966         $(BUILD_BASH_COMPLETION) \
967         $(CHECK_HEADER) \
968         $(DOCPP) \
969         $(PYTHON_BOOTSTRAP) \
970         qa
971
972 test/daemon-util_unittest.bash: daemons/daemon-util
973
974 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
975
976 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
977         sed -f $(REPLACE_VARS_SED) < $< > $@
978         chmod +x $@
979
980 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
981         sed -f $(REPLACE_VARS_SED) < $< > $@
982         chmod u+x $@
983
984 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
985         sed -f $(REPLACE_VARS_SED) < $< > $@
986         chmod +x $@
987
988 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
989         sed -f $(REPLACE_VARS_SED) < $< > $@
990
991 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
992         sed -f $(REPLACE_VARS_SED) < $< > $@
993
994 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
995         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
996         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
997
998 doc/%.png: doc/%.dot
999         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1000         $(DOT) -Tpng -o $@ $<
1001
1002 man/footer.man: man/footer.rst
1003         @test -n "$(PANDOC)" || \
1004           { echo 'pandoc' not found during configure; exit 1; }
1005         $(PANDOC) -f rst -t man -o $@ $<
1006
1007 man/footer.html: man/footer.rst
1008         @test -n "$(PANDOC)" || \
1009           { echo 'pandoc' not found during configure; exit 1; }
1010         $(PANDOC) -f rst -t html -o $@ $<
1011
1012 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1013         lib/build/shell_example_lexer.py \
1014         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1015         @echo "Checking $< for hardcoded paths..."
1016         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1017           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1018           exit 1; \
1019         fi
1020         set -e ; \
1021         trap 'echo auto-removing $@; rm $@' EXIT; \
1022         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1023         trap - EXIT
1024
1025 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1026         @test -n "$(PANDOC)" || \
1027           { echo 'pandoc' not found during configure; exit 1; }
1028         set -o pipefail ; \
1029         trap 'echo auto-removing $@; rm $@' EXIT; \
1030         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1031           sed -e 's/\\@/@/g' > $@; \
1032         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1033         $(CHECK_MAN_DASHES) $@; \
1034         trap - EXIT
1035
1036
1037 man/%.html.in: man/%.gen man/footer.html
1038         @test -n "$(PANDOC)" || \
1039           { echo 'pandoc' not found during configure; exit 1; }
1040         set -o pipefail ; \
1041         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1042           sed -e 's/\\@/@/g' > $@
1043
1044 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1045         sed -f $(REPLACE_VARS_SED) < $< > $@
1046
1047 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1048         sed -f $(REPLACE_VARS_SED) < $< > $@
1049
1050 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1051         sed -f $(REPLACE_VARS_SED) < $< > $@
1052
1053 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1054         sed -f $(REPLACE_VARS_SED) < $< > $@
1055
1056 epydoc.conf: epydoc.conf.in Makefile
1057         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1058
1059 vcs-version:
1060         if test -d .git; then \
1061           git describe > $@; \
1062         elif test ! -f $@ ; then \
1063           echo "Cannot auto-generate $@ file"; exit 1; \
1064         fi
1065
1066 .PHONY: clean-vcs-version
1067 clean-vcs-version:
1068         rm -f vcs-version
1069
1070 .PHONY: regen-vcs-version
1071 regen-vcs-version:
1072         set -e; \
1073         cd $(srcdir); \
1074         if test -d .git; then \
1075           $(MAKE) clean-vcs-version; \
1076           $(MAKE) vcs-version; \
1077         fi
1078
1079 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1080         set -e; \
1081         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1082         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1083
1084 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1085         lib/constants.py lib/_autoconf.py lib/luxi.py \
1086         $(CONVERT_CONSTANTS) \
1087         | lib/_vcsversion.py
1088         set -e; \
1089         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1090
1091 lib/_autoconf.py: Makefile | lib/.dir
1092         set -e; \
1093         { echo '# This file is automatically generated, do not edit!'; \
1094           echo '#'; \
1095           echo ''; \
1096           echo '"""Build-time configuration for Ganeti.'; \
1097           echo '';\
1098           echo 'This file is autogenerated by the build process.'; \
1099           echo 'For any changes you need to re-run ./configure (and'; \
1100           echo 'not edit by hand).'; \
1101           echo ''; \
1102           echo '"""'; \
1103           echo ''; \
1104           echo '# pylint: disable=C0301,C0324'; \
1105           echo '# because this is autogenerated, we do not want'; \
1106           echo '# style warnings' ; \
1107           echo ''; \
1108           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1109           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1110           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1111           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1112           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1113           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1114           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1115           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1116           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1117           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1118           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1119           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1120           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1121           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1122           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1123           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1124           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1125           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1126           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1127           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1128           echo "KVM_PATH = '$(KVM_PATH)'"; \
1129           echo "IP_PATH = '$(IP_PATH)'"; \
1130           echo "SOCAT_PATH = '$(SOCAT)'"; \
1131           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1132           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1133           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1134           echo "TOOLSDIR = '$(toolsdir)'"; \
1135           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1136           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1137           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1138           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1139           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1140           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1141           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1142           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1143           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1144           echo "RAPI_USER = '$(RAPI_USER)'"; \
1145           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1146           echo "CONFD_USER = '$(CONFD_USER)'"; \
1147           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1148           echo "NODED_USER = '$(NODED_USER)'"; \
1149           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1150           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1151           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1152           if [ "$(HTOOLS)" ]; then \
1153             echo "HTOOLS = True"; \
1154           else \
1155             echo "HTOOLS = False"; \
1156           fi; \
1157           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1158           echo "PY_CONFD = $(PY_CONFD)"; \
1159           echo "HS_CONFD = $(HS_CONFD)"; \
1160           echo "XEN_CMD = '$(XEN_CMD)'"; \
1161         } > $@
1162
1163 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1164         set -e; \
1165         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1166         { echo '# This file is automatically generated, do not edit!'; \
1167           echo '#'; \
1168           echo ''; \
1169           echo '"""Build-time VCS version number for Ganeti.'; \
1170           echo '';\
1171           echo 'This file is autogenerated by the build process.'; \
1172           echo 'For any changes you need to re-run ./configure (and'; \
1173           echo 'not edit by hand).'; \
1174           echo ''; \
1175           echo '"""'; \
1176           echo ''; \
1177           echo '# pylint: disable=C0301,C0324'; \
1178           echo '# because this is autogenerated, we do not want'; \
1179           echo '# style warnings' ; \
1180           echo ''; \
1181           echo "VCS_VERSION = '$$VCSVER'"; \
1182         } > $@
1183
1184 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1185         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1186
1187 $(REPLACE_VARS_SED): Makefile
1188         set -e; \
1189         { echo 's#@PREFIX@#$(prefix)#g'; \
1190           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1191           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1192           echo 's#@BINDIR@#$(bindir)#g'; \
1193           echo 's#@SBINDIR@#$(sbindir)#g'; \
1194           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1195           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1196           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1197           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1198           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1199           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1200           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1201           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1202           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1203           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1204           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1205           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1206           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1207           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1208           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1209           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1210           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1211           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1212           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1213         } > $@
1214
1215 # Using deferred evaluation
1216 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1217 daemons/ganeti-watcher: MODULE = ganeti.watcher
1218 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1219 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1220 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1221
1222 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1223         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1224         set -e; \
1225         { echo '#!/usr/bin/python'; \
1226           echo '# This file is automatically generated, do not edit!'; \
1227           echo "# Edit $(MODULE) instead."; \
1228           echo; \
1229           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1230           echo; \
1231           echo '# pylint: disable=C0103'; \
1232           echo '# C0103: Invalid name'; \
1233           echo; \
1234           echo 'import sys'; \
1235           echo 'import $(MODULE) as main'; \
1236           echo; \
1237           echo '# Temporarily alias commands until bash completion'; \
1238           echo '# generator is changed'; \
1239           echo 'if hasattr(main, "commands"):'; \
1240           echo '  commands = main.commands # pylint: disable=E1101'; \
1241           echo 'if hasattr(main, "aliases"):'; \
1242           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1243           echo; \
1244           echo 'if __name__ == "__main__":'; \
1245           echo '  sys.exit(main.Main())'; \
1246         } > $@
1247         chmod u+x $@
1248
1249 $(HS_BUILT_TEST_HELPERS): Makefile
1250         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1251         set -e; \
1252         { echo '#!/bin/sh'; \
1253           echo '# This file is automatically generated, do not edit!'; \
1254           echo "# Edit Makefile.am instead."; \
1255           echo; \
1256           echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1257         } > $@
1258         chmod u+x $@
1259
1260 # We need to create symlinks because "make distcheck" will not install Python
1261 # files when building.
1262 stamp-srclinks: Makefile | $(all_dirfiles)
1263         set -e; \
1264         for i in $(srclink_files); do \
1265                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1266                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1267                 fi; \
1268         done
1269         touch $@
1270
1271 .PHONY: ganeti
1272 ganeti:
1273         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1274
1275 .PHONY: check-dirs
1276 check-dirs: $(BUILT_SOURCES)
1277         @set -e; \
1278         find . -type d \( \( -name . \) -o \( \
1279                 -name .git -o \
1280                 -name autom4te.cache \
1281                 \) -prune -o -print \) | { \
1282                 error=; \
1283                 while read dir; do \
1284                         case "$$dir" in \
1285                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1286                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1287                         esac; \
1288                 done; \
1289                 for dir in $(DIRS); do \
1290                         if ! test -d "$$dir"; then \
1291                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1292                                 error=1; \
1293                         fi \
1294                 done; \
1295                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1296         }
1297
1298 .PHONY: check-local
1299 check-local: check-dirs $(BUILT_SOURCES)
1300         $(CHECK_PYTHON_CODE) $(check_python_code)
1301         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1302         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1303         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1304         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1305         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1306         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1307                 echo "Incorrect version in README, expected $$expver"; \
1308                 exit 1; \
1309         fi; \
1310         for file in doc/iallocator.rst doc/hooks.rst; do \
1311                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1312                         "Documents Ganeti version $$expver"; then \
1313                         echo "Incorrect version in $$file, expected $$expver"; \
1314                         exit 1; \
1315                 fi; \
1316         done
1317
1318 .PHONY: hs-check
1319 hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1320         @rm -f test.tix
1321         ./htools/test
1322         HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1323
1324 # E111: indentation is not a multiple of four
1325 # E261: at least two spaces before inline comment
1326 # E501: line too long (80 characters)
1327 PEP8_IGNORE = E111,E261,E501
1328
1329 # For excluding pep8 expects filenames only, not whole paths
1330 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1331
1332 LINT_TARGETS = pylint pylint-qa
1333 if HAS_PEP8
1334 LINT_TARGETS += pep8
1335 endif
1336 if HAS_HLINT
1337 LINT_TARGETS += hlint
1338 endif
1339
1340 .PHONY: lint
1341 lint: $(LINT_TARGETS)
1342
1343 .PHONY: pylint
1344 pylint: $(BUILT_SOURCES)
1345         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1346         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1347
1348 .PHONY: pylint-qa
1349 pylint-qa: $(BUILT_SOURCES)
1350         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1351         cd $(top_srcdir)/qa && \
1352           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1353           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1354
1355 .PHONY: pep8
1356 pep8: $(BUILT_SOURCES)
1357         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1358         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1359                 --repeat $(pep8_python_code)
1360
1361 .PHONY: hlint
1362 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1363         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1364         if tty -s; then C="-c"; else C=""; fi; \
1365         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1366           --ignore "Use first" \
1367           --ignore "Use comparing" \
1368           --ignore "Use on" \
1369           --ignore "Reduce duplication" \
1370           --hint htools/lint-hints \
1371           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1372
1373 # a dist hook rule for updating the vcs-version file; this is
1374 # hardcoded due to where it needs to build the file...
1375 dist-hook:
1376         $(MAKE) regen-vcs-version
1377         rm -f $(top_distdir)/vcs-version
1378         cp -p $(srcdir)/vcs-version $(top_distdir)
1379
1380 # a distcheck hook rule for catching revision control directories
1381 distcheck-hook:
1382         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1383                 echo "Found revision control files in final archive." 1>&2; \
1384                 exit 1; \
1385         fi
1386         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1387                 echo "Found Python byte code in final archive." 1>&2; \
1388                 exit 1; \
1389         fi
1390         if find $(top_distdir) -name '*~' | grep .; then \
1391                 echo "Found backup files in final archive." 1>&2; \
1392                 exit 1; \
1393         fi
1394 # Empty files or directories should not be distributed. They can cause
1395 # unnecessary warnings for packagers. Directories used by automake during
1396 # distcheck must be excluded.
1397         if find $(top_distdir) -empty -and -not \( \
1398                         -path $(top_distdir)/_build -or \
1399                         -path $(top_distdir)/_inst \) | grep .; then \
1400                 echo "Found empty files or directories in final archive." 1>&2; \
1401                 exit 1; \
1402         fi
1403         if test -n "$(BUILD_RELEASE)" && \
1404            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1405                 echo "Found unreleased version in NEWS." >&2; \
1406                 exit 1; \
1407         fi
1408
1409 # When building a release, stricter checks should be used
1410 distcheck-release dist-release: export BUILD_RELEASE = 1
1411 distcheck-release: distcheck
1412
1413 distrebuildcheck: dist
1414         set -e; \
1415         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1416         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1417         cd $$builddir; \
1418         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1419         cd $(distdir); \
1420         ./configure; \
1421         $(MAKE) maintainer-clean; \
1422         cp $(abs_srcdir)/vcs-version .; \
1423         ./configure; \
1424         $(MAKE) $(AM_MAKEFLAGS)
1425
1426 dist-release: dist
1427         set -e; \
1428         for i in $(DIST_ARCHIVES); do \
1429                 echo -n "Checking $$i ... "; \
1430                 autotools/check-tar < $$i; \
1431                 echo OK; \
1432         done
1433
1434 install-exec-local:
1435         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1436           "$(DESTDIR)${localstatedir}/log/ganeti" \
1437           "$(DESTDIR)${localstatedir}/run/ganeti"
1438
1439 # To avoid conflicts between directory names and other targets, a file inside
1440 # the directory is used to ensure its existence.
1441 %.dir:
1442         @mkdir_p@ $* && touch $@
1443
1444 .PHONY: apidoc
1445 if WANT_HTOOLSAPIDOC
1446 apidoc: py-apidoc hs-apidoc
1447 else
1448 apidoc: py-apidoc
1449 endif
1450
1451 .PHONY: py-apidoc
1452 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1453         $(RUN_IN_TEMPDIR) epydoc -v \
1454                 --conf $(CURDIR)/epydoc.conf \
1455                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1456
1457 .PHONY: hs-apidoc
1458 hs-apidoc: $(HS_BUILT_SRCS)
1459         @test -n "$(HSCOLOUR)" || \
1460             { echo 'HsColour' not found during configure; exit 1; }
1461         @test -n "$(HADDOCK)" || \
1462             { echo 'haddock' not found during configure; exit 1; }
1463         rm -rf $(APIDOC_HS_DIR)/*
1464         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1465         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1466         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1467         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1468         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1469         set -e ; \
1470         cd htools; \
1471         if [ "$(HTOOLS_NOCURL)" ]; \
1472         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1473         else OPTGHC=""; \
1474         fi; \
1475         if [ "$(HTOOLS_PARALLEL3)" ]; \
1476         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1477         fi; \
1478         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1479         for file in $$RELSRCS; do \
1480                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1481                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1482         done ; \
1483         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1484                 -t ganeti-htools -p haddock-prologue \
1485                 --source-module="%{MODULE/.//}.html" \
1486                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1487                 $$OPTGHC \
1488                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1489
1490 .PHONY: TAGS
1491 TAGS: $(BUILT_SOURCES)
1492         rm -f TAGS
1493         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1494           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1495           -path './qa/*.py' | \
1496           etags -l python -
1497
1498 .PHONY: coverage
1499 if WANT_HTOOLS
1500 coverage: py-coverage hs-coverage
1501 else
1502 coverage: py-coverage
1503 endif
1504
1505 .PHONY: py-coverage
1506 py-coverage: $(BUILT_SOURCES) $(python_tests)
1507         set -e; \
1508         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1509         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1510         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1511         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1512         $(python_tests)
1513
1514 .PHONY: hs-coverage
1515 hs-coverage: $(haskell_tests) htools/hpc-htools
1516         rm -f *.tix
1517         $(MAKE) hs-check
1518         @mkdir_p@ $(COVERAGE_HS_DIR)
1519         hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1520         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1521         hpc report coverage-htools.tix
1522         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1523
1524 # Special "kind-of-QA" target for htools, needs special setup (all
1525 # tools compiled with -fhpc)
1526 .PHONY: live-test
1527 live-test: all
1528         set -e ; \
1529         cd htools; \
1530         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1531         rm -f *.tix *.mix; \
1532         ./live-test.sh; \
1533         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1534           --output=live-test.tix ; \
1535         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1536         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1537                 --srcdir=.. $(HPCEXCL) ; \
1538         hpc report --srcdir=.. live-test $(HPCEXCL)
1539
1540 commit-check: distcheck lint apidoc
1541
1542 .PHONY: gitignore-check
1543 gitignore-check:
1544         @if [ -n "`git status --short`" ]; then \
1545           echo "Git status is not clean!" 1>&2 ; \
1546           git status --short; \
1547           exit 1; \
1548         fi
1549
1550 -include ./Makefile.local
1551
1552 # vim: set noet :